<?php
/*

Author:		Václav Pešice - UpStyle systems
E-mail:		vaclavpesice@upstyle.cz
Web:		www.upstyle.cz
License:	CreativeCommons 4.0 Attribution-ShareAlike 4.0 International

*/

class Ups_InvoicepaymentValidationModuleFrontController extends ModuleFrontController
{
	 public $ssl = true;

     public function postProcess()
     {
         if ($this->context->cart->id_customer == 0 || $this->context->cart->id_address_delivery == 0 || $this->context->cart->id_address_invoice == 0 || !$this->module->active) {
             Tools::redirectLink(__PS_BASE_URI__.'order.php?step=1');
         }

         $authorized = false;
         foreach (Module::getPaymentModules() as $module) {
             if ($module['name'] == 'ups_invoicepayment') {
                 $authorized = true;
                 break;
             }
         }
         if (!$authorized) {
             die(Tools::displayError('This payment method is not available.'));
         }
         $customer = new Customer($this->context->cart->id_customer);
         if (!Validate::isLoadedObject($customer)) {
             Tools::redirectLink(__PS_BASE_URI__.'order.php?step=1');
         }
         $customer = new Customer((int)$this->context->cart->id_customer);
         $total = $this->context->cart->getOrderTotal(true, Cart::BOTH);
		 $this->module->validateOrder(
             (int) $this->context->cart->id,
             Configuration::get('PS_OS_PREPARATION'),
             $total,
             $this->module->displayName,
             null,
             null,
             (int) $this->context->currency->id,
             false,
             $customer->secure_key
         );
		 Tools::redirectLink(__PS_BASE_URI__.'order-confirmation.php?key='.$customer->secure_key.'&id_cart='.(int)$this->context->cart->id.'&id_module='.(int)$this->module->id.'&id_order='.(int)$this->module->currentOrder);
     }

    protected function isValidOrder()
    {
        /*
         * Add your checks right there
         */
        return true;
    }
}
