<?php
/*

Author:		Václav Pešice - UpStyle systems
E-mail:		vaclavpesice@upstyle.cz
Web:		  www.upstyle.cz
License:	CreativeCommons 4.0 Attribution-ShareAlike 4.0 International

*/
use PrestaShop\PrestaShop\Core\Payment\PaymentOption;

if (!defined('_PS_VERSION_')) {
    exit;
}
class Ups_invoicepayment extends PaymentModule
{
  protected $config_form = false;

  public function __construct()
  {
    $this->name = 'ups_invoicepayment';
    $this->version = '1.0.1';
		$this->tab = 'payments_gateways';
    $this->author = 'UpStyle systems';
		$this->need_instance = 1;

		$this->ps_versions_compliancy = array('min' => '1.7', 'max' => _PS_VERSION_);
		$this->controllers = array('validation');
		$this->is_eu_compatible = 1;
    $this->currencies = false;

    $this->bootstrap = true;

    parent::__construct();

		$this->displayName = $this->trans('Platba na splatnost', array(), 'Modules.Invoicepayment.Admin');
    $this->description = $this->trans('Platba na splatnost s komentářem "Pouze státní instituce"', array(), 'Modules.Invoicepayment.Admin');
  }

  public function install()
  {
    if (!parent::install() ||
    	!$this->registerHook('paymentReturn') ||
    	!$this->registerHook('paymentOptions')
    ) {
      return false;
    }
    return true;
  }

  public function uninstall()
  {
    return parent::uninstall();
  }

	public function hookPaymentOptions($params)
	{
    if (!$this->active) {
      return false;
    }
    $formAction = $this->context->link->getModuleLink($this->name, 'validation', array(), true);

		$newOption = new PaymentOption();
    $newOption->setModuleName($this->name)
      ->setCallToActionText($this->trans('Platba na fakturu se splatností', array(), 'Modules.Invoicepayment.Shop'))
      ->setAction($formAction)
      ->setAdditionalInformation($this->fetch('module:ups_invoicepayment/views/templates/hook/ups_invoicepayment_intro.tpl'));

    $payment_options = [
      $newOption,
    ];
    return $payment_options;
	}

    public function hookPaymentReturn($params)
    {
		if (!$this->active) {
			return;
		}
    $this->smarty->assign(array(
        'valid' => true,
    ));
		return $this->fetch('module:ups_invoicepayment/views/templates/hook/payment_return.tpl');
    }

}
